package org.jboss.errai.ioc.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.core.client.RunAsyncCallback;
import java.lang.annotation.Annotation;
import java.util.Set;
import javax.enterprise.event.Event;
import javax.inject.Provider;
import org.jboss.errai.bus.client.api.Message;
import org.jboss.errai.bus.client.framework.Subscription;
import org.jboss.errai.cdi.test.stress.client.local.App;
import org.jboss.errai.cdi.test.stress.client.shared.ConfigurationRequest;
import org.jboss.errai.cdi.test.stress.client.shared.SubscriptionRequest;
import org.jboss.errai.cdi.test.stress.client.shared.SubscriptionResponse;
import org.jboss.errai.cdi.test.stress.client.shared.TickEvent;
import org.jboss.errai.enterprise.client.cdi.AbstractCDIEventCallback;
import org.jboss.errai.enterprise.client.cdi.CDIEventTypeLookup;
import org.jboss.errai.enterprise.client.cdi.CDIProtocol;
import org.jboss.errai.enterprise.client.cdi.EventProvider;
import org.jboss.errai.enterprise.client.cdi.InstanceProvider;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.api.ContextualTypeProvider;
import org.jboss.errai.ioc.client.api.builtin.CallerProvider;
import org.jboss.errai.ioc.client.api.builtin.DisposerProvider;
import org.jboss.errai.ioc.client.api.builtin.IOCBeanManagerProvider;
import org.jboss.errai.ioc.client.api.builtin.InitBallotProvider;
import org.jboss.errai.ioc.client.api.builtin.MessageBusProvider;
import org.jboss.errai.ioc.client.api.builtin.RequestDispatcherProvider;
import org.jboss.errai.ioc.client.api.builtin.RootPanelProvider;
import org.jboss.errai.ioc.client.api.builtin.SenderProvider;
import org.jboss.errai.ioc.client.api.qualifiers.Any;
import org.jboss.errai.ioc.client.api.qualifiers.BuiltInQualifiers;
import org.jboss.errai.ioc.client.container.BeanRef;
import org.jboss.errai.ioc.client.container.CreationalCallback;
import org.jboss.errai.ioc.client.container.CreationalContext;
import org.jboss.errai.ioc.client.container.DestructionCallback;
import org.jboss.errai.ioc.client.container.IOCBeanManager;
import org.jboss.errai.ioc.client.container.InitializationCallback;

public class BootstrapperImpl implements Bootstrapper {
  private native static void org_jboss_errai_ioc_client_api_builtin_DisposerProvider_beanManager(DisposerProvider instance, IOCBeanManager value) /*-{
    instance.@org.jboss.errai.ioc.client.api.builtin.DisposerProvider::beanManager = value;
  }-*/;

  private native static void org_jboss_errai_cdi_test_stress_client_local_App_subscriptionEvent(App instance, Event value) /*-{
    instance.@org.jboss.errai.cdi.test.stress.client.local.App::subscriptionEvent = value;
  }-*/;

  private native static void org_jboss_errai_cdi_test_stress_client_local_App_configurationEvent(App instance, Event value) /*-{
    instance.@org.jboss.errai.cdi.test.stress.client.local.App::configurationEvent = value;
  }-*/;

  // The main IOC bootstrap method.
  public BootstrapperInjectionContext bootstrapContainer() {
    CDIEventTypeLookup.get().addLookup("org.jboss.errai.cdi.test.stress.client.shared.ConfigurationRequest", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.jboss.errai.cdi.test.stress.client.shared.TickEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.jboss.errai.cdi.test.stress.client.shared.SubscriptionResponse", "java.lang.Object");
    new CDI().__resetSubsystem();
    new CDI().initLookupTable(CDIEventTypeLookup.get());
    final BootstrapperInjectionContext injContext = new BootstrapperInjectionContext();
    CreationalContext context = injContext.getRootContext();
    final CreationalCallback<CallerProvider> inj1716_CallerProvider_creationalCallback = new CreationalCallback<CallerProvider>() {
      public CallerProvider getInstance(final CreationalContext context) {
        Class beanType = CallerProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final CallerProvider inj1699_CallerProvider = new CallerProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1699_CallerProvider);
        return inj1699_CallerProvider;
      }
    };
    final CallerProvider inj1699_CallerProvider = inj1716_CallerProvider_creationalCallback.getInstance(context);
    final CreationalCallback<RequestDispatcherProvider> inj1717_RequestDispatcherProvider_creationalCallback = new CreationalCallback<RequestDispatcherProvider>() {
      public RequestDispatcherProvider getInstance(final CreationalContext context) {
        Class beanType = RequestDispatcherProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final RequestDispatcherProvider inj1703_RequestDispatcherProvider = new RequestDispatcherProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1703_RequestDispatcherProvider);
        return inj1703_RequestDispatcherProvider;
      }
    };
    final RequestDispatcherProvider inj1703_RequestDispatcherProvider = inj1717_RequestDispatcherProvider_creationalCallback.getInstance(context);
    final CreationalCallback<SenderProvider> inj1718_SenderProvider_creationalCallback = new CreationalCallback<SenderProvider>() {
      public SenderProvider getInstance(final CreationalContext context) {
        Class beanType = SenderProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final SenderProvider inj1711_SenderProvider = new SenderProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1711_SenderProvider);
        return inj1711_SenderProvider;
      }
    };
    final SenderProvider inj1711_SenderProvider = inj1718_SenderProvider_creationalCallback.getInstance(context);
    final CreationalCallback<EventProvider> inj1720_EventProvider_creationalCallback = new CreationalCallback<EventProvider>() {
      public EventProvider getInstance(final CreationalContext context) {
        Class beanType = EventProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final EventProvider inj1707_EventProvider = new EventProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1707_EventProvider);
        return inj1707_EventProvider;
      }
    };
    final EventProvider inj1707_EventProvider = inj1720_EventProvider_creationalCallback.getInstance(context);
    final CreationalCallback<MessageBusProvider> inj1721_MessageBusProvider_creationalCallback = new CreationalCallback<MessageBusProvider>() {
      public MessageBusProvider getInstance(final CreationalContext context) {
        Class beanType = MessageBusProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final MessageBusProvider inj1713_MessageBusProvider = new MessageBusProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1713_MessageBusProvider);
        return inj1713_MessageBusProvider;
      }
    };
    final InitializationCallback<App> init_inj531_App = new InitializationCallback<App>() {
      public void init(final App obj) {
        obj.buildUI();
      }
    };
    final MessageBusProvider inj1713_MessageBusProvider = inj1721_MessageBusProvider_creationalCallback.getInstance(context);
    final CreationalCallback<App> inj1719_App_creationalCallback = new CreationalCallback<App>() {
      public App getInstance(final CreationalContext context) {
        Class beanType = App.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final App inj531_App = new App();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj531_App);
        org_jboss_errai_cdi_test_stress_client_local_App_subscriptionEvent(inj531_App, inj1707_EventProvider.provide(new Class[] { SubscriptionRequest.class }, null));
        org_jboss_errai_cdi_test_stress_client_local_App_configurationEvent(inj531_App, inj1707_EventProvider.provide(new Class[] { ConfigurationRequest.class }, null));
        final Subscription var1 = CDI.subscribe("org.jboss.errai.cdi.test.stress.client.shared.SubscriptionResponse", new AbstractCDIEventCallback() {
          {

          }
          public void callback(final Message message) {
            Set<String> msgQualifiers = message.get(Set.class, CDIProtocol.Qualifiers);
            if (qualifierSet.equals(msgQualifiers) || ((msgQualifiers == null) && qualifierSet.isEmpty())) {
              GWT.runAsync(new RunAsyncCallback() {
                public void onFailure(Throwable throwable) {
                  throw new RuntimeException("failed to run asynchronously", throwable);
                }
                public void onSuccess() {
                  inj531_App.subscriptionActivated(message.get(SubscriptionResponse.class, CDIProtocol.BeanReference));
                }
              });
            }
          }
          public String toString() {
            return "Observer: org.jboss.errai.cdi.test.stress.client.shared.SubscriptionResponse []";
          }
        });
        final Subscription var2 = inj1713_MessageBusProvider.get().subscribe("cdi.event:org.jboss.errai.cdi.test.stress.client.shared.SubscriptionResponse", CDI.ROUTING_CALLBACK);
        context.addDestructionCallback(inj531_App, new DestructionCallback<App>() {
          public void destroy(final App obj) {
            var1.remove();
            var2.remove();
          }
        });
        final Subscription var3 = CDI.subscribe("org.jboss.errai.cdi.test.stress.client.shared.ConfigurationRequest", new AbstractCDIEventCallback() {
          {

          }
          public void callback(final Message message) {
            Set<String> msgQualifiers = message.get(Set.class, CDIProtocol.Qualifiers);
            if (qualifierSet.equals(msgQualifiers) || ((msgQualifiers == null) && qualifierSet.isEmpty())) {
              GWT.runAsync(new RunAsyncCallback() {
                public void onFailure(Throwable throwable) {
                  throw new RuntimeException("failed to run asynchronously", throwable);
                }
                public void onSuccess() {
                  inj531_App.configurationChanged(message.get(ConfigurationRequest.class, CDIProtocol.BeanReference));
                }
              });
            }
          }
          public String toString() {
            return "Observer: org.jboss.errai.cdi.test.stress.client.shared.ConfigurationRequest []";
          }
        });
        final Subscription var4 = inj1713_MessageBusProvider.get().subscribe("cdi.event:org.jboss.errai.cdi.test.stress.client.shared.ConfigurationRequest", CDI.ROUTING_CALLBACK);
        context.addDestructionCallback(inj531_App, new DestructionCallback<App>() {
          public void destroy(final App obj) {
            var3.remove();
            var4.remove();
          }
        });
        final Subscription var5 = CDI.subscribe("org.jboss.errai.cdi.test.stress.client.shared.TickEvent", new AbstractCDIEventCallback() {
          {

          }
          public void callback(final Message message) {
            Set<String> msgQualifiers = message.get(Set.class, CDIProtocol.Qualifiers);
            if (qualifierSet.equals(msgQualifiers) || ((msgQualifiers == null) && qualifierSet.isEmpty())) {
              GWT.runAsync(new RunAsyncCallback() {
                public void onFailure(Throwable throwable) {
                  throw new RuntimeException("failed to run asynchronously", throwable);
                }
                public void onSuccess() {
                  inj531_App.tick(message.get(TickEvent.class, CDIProtocol.BeanReference));
                }
              });
            }
          }
          public String toString() {
            return "Observer: org.jboss.errai.cdi.test.stress.client.shared.TickEvent []";
          }
        });
        final Subscription var6 = inj1713_MessageBusProvider.get().subscribe("cdi.event:org.jboss.errai.cdi.test.stress.client.shared.TickEvent", CDI.ROUTING_CALLBACK);
        context.addDestructionCallback(inj531_App, new DestructionCallback<App>() {
          public void destroy(final App obj) {
            var5.remove();
            var6.remove();
          }
        });
        context.addInitializationCallback(inj531_App, init_inj531_App);
        return inj531_App;
      }
    };
    final App inj531_App = inj1719_App_creationalCallback.getInstance(context);
    final CreationalCallback<RootPanelProvider> inj1722_RootPanelProvider_creationalCallback = new CreationalCallback<RootPanelProvider>() {
      public RootPanelProvider getInstance(final CreationalContext context) {
        Class beanType = RootPanelProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final RootPanelProvider inj1701_RootPanelProvider = new RootPanelProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1701_RootPanelProvider);
        return inj1701_RootPanelProvider;
      }
    };
    final RootPanelProvider inj1701_RootPanelProvider = inj1722_RootPanelProvider_creationalCallback.getInstance(context);
    final CreationalCallback<IOCBeanManagerProvider> inj1723_IOCBeanManagerProvider_creationalCallback = new CreationalCallback<IOCBeanManagerProvider>() {
      public IOCBeanManagerProvider getInstance(final CreationalContext context) {
        Class beanType = IOCBeanManagerProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final IOCBeanManagerProvider inj1705_IOCBeanManagerProvider = new IOCBeanManagerProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1705_IOCBeanManagerProvider);
        return inj1705_IOCBeanManagerProvider;
      }
    };
    final IOCBeanManagerProvider inj1705_IOCBeanManagerProvider = inj1723_IOCBeanManagerProvider_creationalCallback.getInstance(context);
    final CreationalCallback<InstanceProvider> inj1724_InstanceProvider_creationalCallback = new CreationalCallback<InstanceProvider>() {
      public InstanceProvider getInstance(final CreationalContext context) {
        Class beanType = InstanceProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final InstanceProvider inj1697_InstanceProvider = new InstanceProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1697_InstanceProvider);
        return inj1697_InstanceProvider;
      }
    };
    final InstanceProvider inj1697_InstanceProvider = inj1724_InstanceProvider_creationalCallback.getInstance(context);
    final CreationalCallback<DisposerProvider> inj1725_DisposerProvider_creationalCallback = new CreationalCallback<DisposerProvider>() {
      public DisposerProvider getInstance(final CreationalContext context) {
        Class beanType = DisposerProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final DisposerProvider inj1715_DisposerProvider = new DisposerProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1715_DisposerProvider);
        org_jboss_errai_ioc_client_api_builtin_DisposerProvider_beanManager(inj1715_DisposerProvider, inj1705_IOCBeanManagerProvider.get());
        return inj1715_DisposerProvider;
      }
    };
    final DisposerProvider inj1715_DisposerProvider = inj1725_DisposerProvider_creationalCallback.getInstance(context);
    final CreationalCallback<InitBallotProvider> inj1726_InitBallotProvider_creationalCallback = new CreationalCallback<InitBallotProvider>() {
      public InitBallotProvider getInstance(final CreationalContext context) {
        Class beanType = InitBallotProvider.class;
        Annotation[] qualifiers = new Annotation[] { new Any() {
            public Class annotationType() {
              return Any.class;
            }
        } };
        final InitBallotProvider inj1709_InitBallotProvider = new InitBallotProvider();
        BeanRef beanRef = context.getBeanReference(beanType, qualifiers);
        context.addBean(beanRef, inj1709_InitBallotProvider);
        return inj1709_InitBallotProvider;
      }
    };
    final InitBallotProvider inj1709_InitBallotProvider = inj1726_InitBallotProvider_creationalCallback.getInstance(context);
    injContext.addBean(CallerProvider.class, inj1716_CallerProvider_creationalCallback, inj1699_CallerProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(ContextualTypeProvider.class, inj1716_CallerProvider_creationalCallback, inj1699_CallerProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(RequestDispatcherProvider.class, inj1717_RequestDispatcherProvider_creationalCallback, inj1703_RequestDispatcherProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(Provider.class, inj1717_RequestDispatcherProvider_creationalCallback, inj1703_RequestDispatcherProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(SenderProvider.class, inj1718_SenderProvider_creationalCallback, inj1711_SenderProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(ContextualTypeProvider.class, inj1718_SenderProvider_creationalCallback, inj1711_SenderProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(EventProvider.class, inj1720_EventProvider_creationalCallback, inj1707_EventProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(ContextualTypeProvider.class, inj1720_EventProvider_creationalCallback, inj1707_EventProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(MessageBusProvider.class, inj1721_MessageBusProvider_creationalCallback, inj1713_MessageBusProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(Provider.class, inj1721_MessageBusProvider_creationalCallback, inj1713_MessageBusProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(App.class, inj1719_App_creationalCallback, inj531_App, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(RootPanelProvider.class, inj1722_RootPanelProvider_creationalCallback, inj1701_RootPanelProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(Provider.class, inj1722_RootPanelProvider_creationalCallback, inj1701_RootPanelProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(IOCBeanManagerProvider.class, inj1723_IOCBeanManagerProvider_creationalCallback, inj1705_IOCBeanManagerProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(Provider.class, inj1723_IOCBeanManagerProvider_creationalCallback, inj1705_IOCBeanManagerProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(InstanceProvider.class, inj1724_InstanceProvider_creationalCallback, inj1697_InstanceProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(ContextualTypeProvider.class, inj1724_InstanceProvider_creationalCallback, inj1697_InstanceProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(DisposerProvider.class, inj1725_DisposerProvider_creationalCallback, inj1715_DisposerProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(ContextualTypeProvider.class, inj1725_DisposerProvider_creationalCallback, inj1715_DisposerProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(InitBallotProvider.class, inj1726_InitBallotProvider_creationalCallback, inj1709_InitBallotProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    injContext.addBean(ContextualTypeProvider.class, inj1726_InitBallotProvider_creationalCallback, inj1709_InitBallotProvider, BuiltInQualifiers.DEFAULT_QUALIFIERS);
    return injContext;
  }
}